/************************************************************************* 
 
    Quick And Dirty Apricot Emulator
    Copyright (C) 2005,2007  John Elliott <jce@seasip.demon.co.uk>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*************************************************************************/

#define VRAMSIZE 0x20000	/* 128k video RAM */

#include "crtc.hxx"


class FP_Video : public Video
{
	CRTC m_crtc;
	u_int8 m_palette[16];
	u_int8 shadowram[VRAMSIZE];
	u_int8 videoram [VRAMSIZE];
	int vscale;
	int v_mode;
	int scr_rows;
	Uint32 m_lcdfg;
	Uint32 m_lcdbg;
	Uint32 colours[16];
public:
	FP_Video(PC_ENV *m);
	virtual ~FP_Video();

	u_int8 read(u_int16 port);
	void write16(u_int16 port, u_int16 value);
	void write(u_int16 port, u_int8 value);

//	void draw_row_2bit(int y, u_int8 *row, u_int8 *shadow, u_int8 *palette);
//	void draw_row_4bit(int y, u_int8 *row, u_int8 *shadow, u_int8 *palette);
	void draw_row_lcd (int y, u_int8 *row, u_int8 *shadow);

	virtual int paint();
	virtual void init();

	void store(u_int32 offset, u_int8 value);
	u_int8 fetch(u_int32 offset);
};

