/*************************************************************************
 
    Quick And Dirty Apricot Emulator
    Copyright (C) 2007,2008  John Elliott <jce@seasip.demon.co.uk>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*************************************************************************/

#ifndef I8259_HXX_INCLUDED
#define I8259_HXX_INCLUDED 1

class PC_ENV;

#define I8259_COUNT 8

class I8259 : public Device, public IntAck
{
public:
	I8259(PC_ENV *host);
	~I8259();

	void write(u_int16 port, u_int8 value);
	u_int8 read(u_int16 port);
	void tick(void);

	void setirq(int irq, bool on);

	virtual void reset();
	virtual bool parseNode(xmlDoc *doc, xmlNs *ns, xmlNode *node);
	virtual bool storeNode(xmlDoc *doc, xmlNs *ns, xmlNode *node);
	virtual u_int8 ackInterrupt(void);

private:
	u_int8	m_icw1, m_icw2, m_icw3, m_icw4;
	u_int8  m_ocw1, m_ocw2, m_ocw3;
	u_int8	m_mask, m_irr, m_isr;
	bool	m_haveIcw2, m_haveIcw3, m_haveIcw4, m_haveOcw2, m_haveOcw3;
	bool	m_realirq[8];
	bool	m_lastirq[8];
	bool	m_raising[8];
//	int	m_raiseAgain;

	void setICW1(u_int8 value);
	void setMask(u_int8 value);

private:
	PC_ENV *m_host;
};
#endif //ndef I8259_HXX_INCLUDED

