/************************************************************************* 
 
    Quick And Dirty Apricot Emulator
    Copyright (C) 2005-7  John Elliott <jce@seasip.demon.co.uk>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*************************************************************************/


class PC_ENV;

class Keyboard : public Device
{
public:
	Keyboard(PC_ENV *m, std::string name);
	virtual ~Keyboard();

	virtual void reset();
	virtual bool parseNode(xmlDoc *doc, xmlNs *ns, xmlNode *cur);
	virtual bool storeNode(xmlDoc *doc, xmlNs *ns, xmlNode *cur);

	virtual UiEvent keyboard_event(SDL_Event *e);
	virtual void send_time();

private:
	void setkey(int *map, int pckey, int sdlkey);
	int get_number(char **ptr, int def, int star = 0, SDLMod *mod = NULL);


protected:
	PC_ENV *host;

	int pcxi_key_map[SDLK_LAST + 1 - SDLK_FIRST];
	int rascal_key_map[SDLK_LAST + 1 - SDLK_FIRST];
	int xen_key_map[SDLK_LAST + 1 - SDLK_FIRST];

/* A second keymap for things that happen when the right-hand ALT key is 
 * pressed */
	int pcxi_key_ralt[SDLK_LAST + 1 - SDLK_FIRST];
	int rascal_key_ralt[SDLK_LAST + 1 - SDLK_FIRST];
	int xen_key_ralt[SDLK_LAST + 1 - SDLK_FIRST];
};
