/*************************************************************************
 
    Quick And Dirty Apricot Emulator
    Copyright (C) 2005-6  John Elliott <jce@seasip.demon.co.uk>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*************************************************************************/

class PC_ENV;

class SdlTerm;

class Video: public Device
{
public:
	Video(PC_ENV *m, std::string name, int width, int height);
	virtual ~Video();

	virtual void reset();
	virtual void init();
        virtual bool parseNode(xmlDoc *doc, xmlNs *ns, xmlNode *cur);
        virtual bool storeNode(xmlDoc *doc, xmlNs *ns, xmlNode *cur);

	virtual void write(u_int16 port, u_int8 value) = 0;
	virtual u_int8 read(u_int16 port);

	void captureMouse(bool captured);
	bool isMouseCaptured();
	virtual int paint() = 0;

protected:
	int width;
	int height;
	int extra_height;
	bool mouse_captured;
	SdlTerm *term;
	SDL_Surface *vidSurface;
	SDL_Thread *vidThread;
	PC_ENV *host;
};



EXT u_int8 gl_dirty;
EXT u_int8 gl_ledsdirty;
EXT u_int8 gl_caps;	/* Caps lock LED */
EXT u_int8 gl_stop;	/* Stop LED */
EXT int	   gl_f10count;	/* Countdown to automatic press of F10 */

