/*************************************************************************
 
    Quick And Dirty Apricot Emulator
    Copyright (C) 2005  John Elliott <jce@seasip.demon.co.uk>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*************************************************************************/

#ifndef Z80_CTC_HXX
#define Z80_CTC_HXX

class PC_ENV;

class Z80_CTC : public Device, public IntAck
{
public:
	Z80_CTC(PC_ENV *host);
	~Z80_CTC();

	void opcode(u_int8 value);
	void write(u_int16 port, u_int8 value);
	u_int8 read(u_int16 port);
	u_int8 tick(void);
	void raise(int channel);
	virtual void reset();
	virtual bool parseNode(xmlDoc *doc, xmlNs *ns, xmlNode *node);
	virtual bool storeNode(xmlDoc *doc, xmlNs *ns, xmlNode *node);
	virtual u_int8 ackInterrupt(void);

private:
	u_int8 last_z80_op;
	u_int8 irq_base;
	u_int8 last_irq;
	u_int8 expect_timer_word[4];
	u_int8 timer_word[4];
	u_int16 countdown[4];
	u_int8 channel_word[4];
	int raising;

	void set_countdown(int channel);
	PC_ENV *pc_env;
};

#endif //ndef Z80_CTC_HXX

