
Name "QDAE"
OutFile "qdaesetup.exe"
InstallDir $PROGRAMFILES\QDAE
;InstalDirRegKey HKLM "Software\jce@seasip\QDAE" "Install_Dir"

; Pages

Page components
Page directory
Page instfiles

UninstPage uninstConfirm
UninstPage instfiles

; Files to install

Section "Programs"
  SectionIn RO
  SetOutPath $INSTDIR
  File "../bin/qdae.exe"
  File "../bin/SDL.dll"
  File "../Docs/qdae.txt"
  File "../Docs/keyboard.txt"
  SetOutPath $INSTDIR\Lib\Keyboards
  File "../share/uk.kbd"
  SetOutPath $INSTDIR\Lib\Bitmaps
  File "../share/uscreen.bmp"
  SetOutPath $INSTDIR
  WriteRegStr HKLM SOFTWARE\jce@seasip\QDAE "Install_Dir" "$INSTDIR"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\QDAE" "DisplayName" "QDAE" 
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\QDAE" "UninstallString" "$INSTDIR\uninstall.exe" 
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\QDAE" "NoModify" 1
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\QDAE" "NoRepair" 1
  WriteUninstaller "uninstall.exe"

; Start menu shortcuts
  CreateDirectory "$SMPROGRAMS\QDAE"
  CreateShortCut "$SMPROGRAMS\QDAE\Uninstall.lnk" "$INSTDIR\uninstall.exe" "" "$INSTDIR\uninstall.exe" 0
  CreateShortCut "$SMPROGRAMS\QDAE\QDAE (F series).lnk" "$INSTDIR\qdae.exe" "-mf1" "$INSTDIR\qdae.exe" 0
  CreateShortCut "$SMPROGRAMS\QDAE\QDAE (PC or Xi).lnk" "$INSTDIR\qdae.exe" "-mxi" "$INSTDIR\qdae.exe" 0
  CreateShortCut "$SMPROGRAMS\QDAE\Documentation.lnk" "$INSTDIR\qdae.txt" "" "$INSTDIR\qdae.txt" 0
SectionEnd

Section "Source code"
  SetOutPath $INSTDIR
  File "../qdae-0.0.4.tar.gz"

SectionEnd

; Uninstaller
Section "Uninstall"
  ; Clean registry
  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\QDAE"
  DeleteRegKey HKLM SOFTWARE\jce@seasip\QDAE
  ; Remove programs
  Delete $INSTDIR\qdae.exe
  Delete $INSTDIR\SDL.dll
  Delete $INSTDIR\qdae.txt
  Delete $INSTDIR\keyboard.txt
  Delete $INSTDIR\qdae-0.0.4.tar.gz
  Delete $INSTDIR\lib\Keyboards\uk.kbd
  Delete $INSTDIR\lib\Bitmaps\uscreen.bmp
  Delete $INSTDIR\uninstall.exe
  ; Remove shortcuts
  Delete "$SMPROGRAMS\QDAE\*.*"
  ; Remove directories
  RMDir "$SMPROGRAMS\QDAE"
  RMDir "$INSTDIR\lib\Keyboards"
  RMDir "$INSTDIR\lib\Bitmaps"
  RMDir "$INSTDIR\lib"
  RMDir "$INSTDIR"

SectionEnd

